/***Capitanu Roxana - Steliana
***332 CC
***/

#include <avr/io.h>
#define F_CPU 21000000
#include<util/delay.h>
void aprinde_leduri(){
	PORTA = PORTA |(1 << PA0);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA1);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA2);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA3);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA4);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA5);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA6);
	_delay_ms(500);
	PORTA = PORTA |(1 << PA7);
	_delay_ms(500);
	PORTB = PORTB |(1 << PB0);
	_delay_ms(500);
	
}
void stinge_leduri(){
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA5);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}
int main(){
	
	
	
	/**setam pinii de iesire
	***pentru fiecare coloana
	***de leduri
	***/
	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA3);
	DDRA |= (1 << PA4);
	DDRA |= (1 << PA5);
	DDRA |= (1 << PA6);
	DDRA |= (1 << PA7);
	DDRB |= (1 << PA0);
	/**setam pinii de iesire
	***pentru fiecare nivel
	***de leduri
	***/
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB3);
	
	while(1){
		
		
		/***animatie 1
		****aprindem si stingem ledurile de pe fiecare nivel in ordine
		****primul nivel
		***/
		PORTB = PORTB |(1 << PB1);
		
		aprinde_leduri();
		
		stinge_leduri();
		
		/* al doilea nivel */
		PORTB &= ~(1 << PB1);
		
		_delay_ms(500);

		PORTB = PORTB |(1 << PB2);
		
		aprinde_leduri();
		
		stinge_leduri();
		
		PORTB &= ~(1 << PB2);
		
		_delay_ms(500);
		
		/*al treilea nivel */
		PORTB = PORTB |(1 << PB3);
		
		aprinde_leduri();
		
		stinge_leduri();
		
		PORTB &= ~(1 << PB3);
		
		
		/***animatie2
		****aprindem toate ledurile concomitent 
		*****pe fiecare nivel
		****/
		aprinde_leduri();
		
		PORTB = PORTB |(1 << PB1);
		_delay_ms(1000);
		
		PORTB = PORTB |(1 << PB2);
		_delay_ms(1000);
		
		PORTB = PORTB |(1 << PB3);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		PORTB &= ~(1 << PB1);
		PORTB &= ~(1 << PB2);
		PORTB &= ~(1 << PB3);
		_delay_ms(1000);
		
		
		/***animatie 3
		****aprindem toate ledurile concomitent
		****de pe fiecare latura verticala a cubului
		****/
		PORTA = PORTA |(1 << PA0);
		PORTA = PORTA |(1 << PA1);
		PORTA = PORTA |(1 << PA2);
		
		/***aprindem toate ledurile
		****de pe prima latura verticala
		****/
		PORTB = PORTB |(1 << PB1);		
		PORTB = PORTB |(1 << PB2);
		PORTB = PORTB |(1 << PB3);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		
		/***aprindem toate ledurile
		****de pe urmatoarea latura verticala
		****/
		PORTA = PORTA |(1 << PA3);
		PORTA = PORTA |(1 << PA7);
		PORTB = PORTB |(1 << PB0);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		
		/***aprindem toate ledurile
		****de pe ultima latura verticala
		****/
		PORTA = PORTA |(1 << PA6);
		PORTA = PORTA |(1 << PA4);
		PORTA = PORTA |(1 << PA5);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		PORTB &= ~(1 << PB1);
		PORTB &= ~(1 << PB2);
		PORTB &= ~(1 << PB3);
		_delay_ms(1000);
		
		
		/***animatie 4
		****aprindem ledurile in trepte
		****/
		PORTB = PORTB |(1 << PB3);
		
		/***aprindem toate ledurile
		****de pe treapta inferioara
		****/
		PORTA = PORTA |(1 << PA0);
		PORTA = PORTA |(1 << PA7);
		PORTA = PORTA |(1 << PA6);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		
		PORTB = PORTB |(1 << PB2);
		
		/***aprindem toate ledurile
		****de pe primele 2 trepte
		****/
		PORTA = PORTA |(1 << PA1);
		PORTB = PORTB |(1 << PB0);
		PORTA = PORTA |(1 << PA5);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		
		PORTB = PORTB |(1 << PB1);
		
		/***aprindem toate ledurile
		****de pe latura verticala
		****/
		PORTA = PORTA |(1 << PA2);
		PORTA = PORTA |(1 << PA3);
		PORTA = PORTA |(1 << PA4);
		_delay_ms(1000);
		
		/***stingem toate ledurile
		****/
		stinge_leduri();
		PORTB &= ~(1 << PB1);
		PORTB &= ~(1 << PB2);
		PORTB &= ~(1 << PB3);
		_delay_ms(1000);
		
	}
	
	return 0;
}